commit 8799006ab889b8bd8a6d6fbea5ddb64a17b2e541
Author: Xi Ruoyao <xry111@mengyan1223.wang>
Date:   Sun Jan 30 18:15:20 2022

    fold-const: do not fold NaN result from non-NaN operands [PR95115]
    
    These operations should raise an invalid operation exception at runtime.
    So they should not be folded during compilation unless -fno-trapping-math
    is used.
    
    gcc/
            PR middle-end/95115
            * fold-const.c (const_binop): Do not fold NaN result from
              non-NaN operands.
    
    gcc/testsuite
            * gcc.dg/pr95115.c: New test.
    
    (cherry picked from commit 34afa19d29c5bf0b0f504e4d0aca4e9a8bc82c5c)

diff --git a/gcc/fold-const.c b/gcc/fold-const.c
index 50afe845c3d..07ab1059088 100644
--- a/gcc/fold-const.c
+++ b/gcc/fold-const.c
@@ -1303,6 +1303,17 @@ const_binop (enum tree_code code, tree arg1, tree arg2)
       inexact = real_arithmetic (&value, code, &d1, &d2);
       real_convert (&result, mode, &value);
 
+      /* Don't constant fold this floating point operation if
+	 both operands are not NaN but the result is NaN, and
+	 flag_trapping_math.  Such operations should raise an
+	 invalid operation exception.  */
+      if (flag_trapping_math
+	  && MODE_HAS_NANS (mode)
+	  && REAL_VALUE_ISNAN (result)
+	  && !REAL_VALUE_ISNAN (d1)
+	  && !REAL_VALUE_ISNAN (d2))
+	return NULL_TREE;
+
       /* Don't constant fold this floating point operation if
 	 the result has overflowed and flag_trapping_math.  */
       if (flag_trapping_math
diff --git a/gcc/testsuite/gcc.dg/pr95115.c b/gcc/testsuite/gcc.dg/pr95115.c
new file mode 100644
index 00000000000..46a95dfb698
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr95115.c
@@ -0,0 +1,25 @@
+/* { dg-do run } */
+/* { dg-options "-O2 -ftrapping-math" } */
+/* { dg-add-options ieee } */
+/* { dg-require-effective-target fenv_exceptions } */
+
+#include <fenv.h>
+#include <stdlib.h>
+
+double
+x (void)
+{
+  double d = __builtin_inf ();
+  return d / d;
+}
+
+int
+main (void)
+{
+  double r = x ();
+  if (!__builtin_isnan (r))
+	abort ();
+  if (!fetestexcept (FE_INVALID))
+	abort ();
+  exit (0);
+}

